// bbkeys.cc for blackbox
// ------ note from the Gee-I'm-Sorry-The-Code-Looks-Ugly department-----
// ------ for vi users-- ":set ts=2"	=:)
//
//	Copyright (c) 1999-2001 by Jason Kasper (vanRijn) vR@movingparts.net
//	Copyright (c) 2001 by Ben Jansens <xor@x-o-r.net>
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// (See the included file COPYING / GPL-2.0)
//

//
// Edited by Henrik Kinnunen (fluxgen@linuxmail.org) for Fluxbox
//

#ifdef		HAVE_CONFIG_H
#	 include "config.h"
#endif

#ifdef		HAVE_STDIO_H
#	 include <stdio.h>
#endif									// HAVE_STDIO_H

#ifdef		HAVE_CTYPE_H
#	 include <ctype.h>
#endif									// HAVE_CTYPE_H

#ifdef		STDC_HEADERS
#	 include <stdlib.h>
#	 include <string.h>
#  include <errno.h>
#endif									// STDC_HEADERS

#if HAVE_STRINGS_H
# include <strings.h>
#endif

#ifdef		HAVE_SYS_TYPES_H
#	 include <sys/types.h>
#endif									// HAVE_SYS_TYPES_H

#ifdef		HAVE_SYS_WAIT_H
#	 include <sys/wait.h>
#endif									// HAVE_SYS_WAIT_H

#ifdef		HAVE_UNISTD_H
#	 include <unistd.h>
#endif									// HAVE_UNISTD_H

#ifdef		HAVE_SYS_STAT_H
#	 include <sys/stat.h>
#endif									// HAVE_SYS_STAT_H

#include <X11/Xlib.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>

#include "Keys.hh"
#include "blackbox.hh"

const Action_t Keys::actions[] = {
										{"Minimize",  grabIconify},
										{"Raise",  grabRaise},
										{"Lower",  grabLower},
										{"Close",  grabClose},
										{"Workspace1",  grabWorkspace1},
										{"Workspace2",  grabWorkspace2},
										{"Workspace3",  grabWorkspace3},
										{"Workspace4",  grabWorkspace4},
										{"Workspace5",  grabWorkspace5},
										{"Workspace6",  grabWorkspace6},
										{"Workspace7",  grabWorkspace7},
										{"Workspace8",  grabWorkspace8},
										{"Workspace9",  grabWorkspace9},
										{"Workspace10",  grabWorkspace10},
										{"Workspace11",  grabWorkspace11},
										{"Workspace12",  grabWorkspace12},
										{"NextWorkspace", grabNextWorkspace},
										{"PrevWorkspace", grabPrevWorkspace},
										{"LeftWorkspace", grabLeftWorkspace},
										{"RightWorkspace", grabRightWorkspace},
										{"NextWindow", grabNextWindow},
										{"PrevWindow", grabPrevWindow},
										{"ShadeWindow", grabShade},
										{"MaximizeWindow", grabMaximize},
										{"StickWindow", grabStick},
										{"ExecCommand", grabExecute},
										{"MaximizeVertical", grabVertMax},
										{"MaximizeHorizontal", grabHorizMax},
										{"NudgeRight", grabNudgeRight},
										{"NudgeLeft", grabNudgeLeft},
										{"NudgeUp", grabNudgeUp},
										{"NudgeDown", grabNudgeDown},
										{"BigNudgeRight", grabBigNudgeRight},
										{"BigNudgeLeft", grabBigNudgeLeft},
										{"BigNudgeUp", grabBigNudgeUp},
										{"BigNudgeDown", grabBigNudgeDown},
										{"HorizontalIncrement", grabHorizInc},
										{"VerticalIncrement", grabVertInc},
										{"HorizontalDecrement", grabHorizDec},
										{"VerticalDecrement", grabVertDec},
										{"ToggleDecor", grabToggleDecor},
										{0, NUM_GRABS}
										};

/*--------------------------------------------------------------------*/

/* Ripped shamelessly from wmaker's xmodifier.c--converted for our use*/

/*--------------------------------------------------------------------*/

/* Grok X modifier mappings for shortcuts.
	 
	 Most of this code was taken from src/event-Xt.c in XEmacs 20.3-b17.
	 The copyright(s) from the original XEmacs code are included below.

	 Perpetrator: Sudish Joseph <sj@eng.mindspring.net>, Sept. 1997. */

/* The event_stream interface for X11 with Xt, and/or tty frames.
	 Copyright (C) 1991, 1992, 1993, 1994, 1995 Free Software Foundation, Inc.
	 Copyright (C) 1995 Sun Microsystems, Inc.
	 Copyright (C) 1996 Ben Wing.

This file is part of XEmacs.

XEmacs is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

XEmacs is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with XEmacs; see the file COPYING.	If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.	 */

/************************************************************************/

/*														keymap handling														*/

/************************************************************************/

/* X bogusly doesn't define the interpretations of any bits besides
	 ModControl, ModShift, and ModLock; so the Interclient Communication
	 Conventions Manual says that we have to bend over backwards to figure
	 out what the other modifier bits mean.	 According to ICCCM:

	 - Any keycode which is assigned ModControl is a "control" key.

	 - Any modifier bit which is assigned to a keycode which generates Meta_L
		 or Meta_R is the modifier bit meaning "meta".	Likewise for Super, Hyper,
		 etc.

	 - Any keypress event which contains ModControl in its state should be
		 interpreted as a "control" character.

	 - Any keypress event which contains a modifier bit in its state which is
		 generated by a keycode whose corresponding keysym is Meta_L or Meta_R
		 should be interpreted as a "meta" character.	 Likewise for Super, Hyper,
		 etc.

	 - It is illegal for a keysym to be associated with more than one modifier
		 bit.

	 This means that the only thing that emacs can reasonably interpret as a
	 "meta" key is a key whose keysym is Meta_L or Meta_R, and which generates
	 one of the modifier bits Mod1-Mod5.

	 Unfortunately, many keyboards don't have Meta keys in their default
	 configuration.	 So, if there are no Meta keys, but there are "Alt" keys,
	 emacs will interpret Alt as Meta.	If there are both Meta and Alt keys,
	 then the Meta keys mean "Meta", and the Alt keys mean "Alt" (it used to
	 mean "Symbol," but that just confused the hell out of way too many people).

	 This works with the default configurations of the 19 keyboard-types I've
	 checked.

	 Emacs detects keyboard configurations which violate the above rules, and
	 prints an error message on the standard-error-output.	(Perhaps it should
	 use a pop-up-window instead.)
 */

static int MetaMask, HyperMask, SuperMask, AltMask, ModeMask;

char *Keys::index_to_name(int indice)
{
	 switch (indice) {
	 case ShiftMapIndex:
			return "ModShift";
	 case LockMapIndex:
			return "ModLock";
	 case ControlMapIndex:
			return "ModControl";
	 case Mod1MapIndex:
			return "Mod1";
	 case Mod2MapIndex:
			return "Mod2";
	 case Mod3MapIndex:
			return "Mod3";
	 case Mod4MapIndex:
			return "Mod4";
	 case Mod5MapIndex:
			return "Mod5";
	 default:
			return "???";
	 }
}

void Keys::x_reset_modifier_mapping(Display * display)
{
	 int modifier_index, modifier_key, column, mkpm;
	 int warned_about_overlapping_modifiers = 0;
	 int warned_about_predefined_modifiers = 0;
	 int warned_about_duplicate_modifiers = 0;
	 int meta_bit = 0;
	 int hyper_bit = 0;
	 int super_bit = 0;
	 int alt_bit = 0;
	 int mode_bit = 0;
	 XModifierKeymap *x_modifier_keymap = XGetModifierMapping(display);

#define modwarn(name,old,other)								\
	warned_about_overlapping_modifiers = 1

#define modbarf(name,other)								\
	warned_about_predefined_modifiers = 1

#define check_modifier(name,mask)							\
		warned_about_predefined_modifiers = 1

#define store_modifier(name,old)						 \
	if (old && old != modifier_index)						 \
		warned_about_duplicate_modifiers = 1;					 \
	if (modifier_index == ShiftMapIndex) modbarf (name,"ModShift");		 \
	else if (modifier_index == LockMapIndex) modbarf (name,"ModLock");		 \
	else if (modifier_index == ControlMapIndex) modbarf (name,"ModControl"); \
	else if (sym == XK_Mode_switch)						 \
		mode_bit = modifier_index; /* Mode_switch is special, see below... */	 \
	else if (modifier_index == meta_bit && old != meta_bit)			 \
		modwarn (name, meta_bit, "Meta");						 \
	else if (modifier_index == super_bit && old != super_bit)			 \
		modwarn (name, super_bit, "Super");						 \
	else if (modifier_index == hyper_bit && old != hyper_bit)			 \
		modwarn (name, hyper_bit, "Hyper");						 \
	else if (modifier_index == alt_bit && old != alt_bit)				 \
		modwarn (name, alt_bit, "Alt");						 \
	else										 \
		old = modifier_index;

	 mkpm = x_modifier_keymap->max_keypermod;
	 for (modifier_index = 0; modifier_index < 8; modifier_index++)
			for (modifier_key = 0; modifier_key < mkpm; modifier_key++) {
				KeySym last_sym = 0;
				for (column = 0; column < 4; column += 2) {
					 KeyCode code =
							x_modifier_keymap->modifiermap[modifier_index * mkpm +
																	modifier_key];
					 KeySym sym =
							(code ? XKeycodeToKeysym(display, code, column) : 0);
					 if (sym == last_sym)
							continue;
					 last_sym = sym;
					 switch (sym) {
					 case XK_Mode_switch:
							store_modifier("Mode_switch", mode_bit);
							break;
					 case XK_Meta_L:
							store_modifier("Meta_L", meta_bit);
							break;
					 case XK_Meta_R:
							store_modifier("Meta_R", meta_bit);
							break;
					 case XK_Super_L:
							store_modifier("Super_L", super_bit);
							break;
					 case XK_Super_R:
							store_modifier("Super_R", super_bit);
							break;
					 case XK_Hyper_L:
							store_modifier("Hyper_L", hyper_bit);
							break;
					 case XK_Hyper_R:
							store_modifier("Hyper_R", hyper_bit);
							break;
					 case XK_Alt_L:
							store_modifier("Alt_L", alt_bit);
							break;
					 case XK_Alt_R:
							store_modifier("Alt_R", alt_bit);
							break;
					 case XK_Control_L:
							check_modifier("Control_L", ControlMask);
							break;
					 case XK_Control_R:
							check_modifier("Control_R", ControlMask);
							break;
					 case XK_Shift_L:
							check_modifier("Shift_L", ShiftMask);
							break;
					 case XK_Shift_R:
							check_modifier("Shift_R", ShiftMask);
							break;
					 case XK_Shift_Lock:
							check_modifier("Shift_Lock", LockMask);
							break;
					 case XK_Caps_Lock:
							check_modifier("Caps_Lock", LockMask);
							break;

							/* It probably doesn't make any sense for a modifier bit to be
								 assigned to a key that is not one of the above, but OpenWindows
								 assigns modifier bits to a couple of random function keys for
								 no reason that I can discern, so printing a warning here would
								 be annoying. */
					 }
				}
			}
#undef store_modifier
#undef check_modifier
#undef modwarn
#undef modbarf

	 /* If there was no Meta key, then try using the Alt key instead.
			If there is both a Meta key and an Alt key, then the Alt key
			is not disturbed and remains an Alt key. */
	 if (!meta_bit && alt_bit)
			meta_bit = alt_bit, alt_bit = 0;

	 /* mode_bit overrides everything, since it's processed down inside of
			XLookupString() instead of by us.	 If Meta and Mode_switch both
			generate the same modifier bit (which is an error), then we don't
			interpret that bit as Meta, because we can't make XLookupString()
			not interpret it as Mode_switch; and interpreting it as both would
			be totally wrong. */
	 if (mode_bit) {
			const char *warn = 0;
			if (mode_bit == meta_bit)
				warn = "Meta", meta_bit = 0;
			else if (mode_bit == hyper_bit)
				warn = "Hyper", hyper_bit = 0;
			else if (mode_bit == super_bit)
				warn = "Super", super_bit = 0;
			else if (mode_bit == alt_bit)
				warn = "Alt", alt_bit = 0;
			if (warn) {
				warned_about_overlapping_modifiers = 1;
			}
	 }

	 MetaMask = (meta_bit ? (1 << meta_bit) : 0);
	 HyperMask = (hyper_bit ? (1 << hyper_bit) : 0);
	 SuperMask = (super_bit ? (1 << super_bit) : 0);
	 AltMask = (alt_bit ? (1 << alt_bit) : 0);
	 ModeMask = (mode_bit ? (1 << mode_bit) : 0); /* unused */

	 if (x_modifier_keymap)
			XFreeModifiermap(x_modifier_keymap);
}


int Keys::translateModifier(char *key)
{
	 if (strcasecmp(key, "SHIFT") == 0 && ShiftMask != 0)
			return ShiftMask;
	 else if (strcasecmp(key, "CONTROL") == 0 && ControlMask != 0)
			return ControlMask;
	 else if (strcasecmp(key, "ALT") == 0 && AltMask != 0)
			return AltMask;
	 else if (strcasecmp(key, "META") == 0 && MetaMask != 0)
			return MetaMask;
	 else if (strcasecmp(key, "SUPER") == 0 && SuperMask != 0)
			return SuperMask;
	 else if (strcasecmp(key, "HYPER") == 0 && HyperMask != 0)
			return HyperMask;
	 else if (strcasecmp(key, "MOD1") == 0 && Mod1Mask != 0)
			return Mod1Mask;
	 else if (strcasecmp(key, "MOD2") == 0 && Mod2Mask != 0)
			return Mod2Mask;
	 else if (strcasecmp(key, "MOD3") == 0 && Mod3Mask != 0)
			return Mod3Mask;
	 else if (strcasecmp(key, "MOD4") == 0 && Mod4Mask != 0)
			return Mod4Mask;
	 else if (strcasecmp(key, "MOD5") == 0 && Mod5Mask != 0)
			return Mod5Mask;
	 else if (strcasecmp(key, "NONE") == 0)
			return None;
	 else
			return -1;
}

/* Wrapper so that we may fit our naming conventions, yet leave the 
	 original XEmacs function name in place. */
void Keys::InitializeModifiers(void)
{
	 x_reset_modifier_mapping(Blackbox::instance()->getXDisplay());
}

/*-----------------------------------------------------------------------*/

/*-- end of shameless rip.	thank you for your support								---*/

/*-----------------------------------------------------------------------*/

void Keys::CheckConfig(const char *rcfile)
{
	 struct stat file_status;

	 if (stat(rcfile, &file_status) != 0) {
#ifdef DEBUG
			fprintf(stderr, "Could not open config file ->%s<-\n",
					 rcfile);
#endif
	 } else {// if (file_status.st_mtime != bbkeys_rcTime) {
			//bbkeys_rcTime = file_status.st_mtime;
			loadKeygrabs(rcfile);
			activateKeygrabs();
	 }
}

void Keys::activateKeygrabs(void)
{
	int i = 0;
	Blackbox *bb = Blackbox::instance();
	Display *display = bb->getXDisplay();

	if (grabSet.instructCount > 0)
		XUngrabKey(display, AnyKey, AnyModifier,
					 bb->getScreenInfo(0)->getRootWindow());
	for (i = 0; i < grabSet.instructCount; i++) {
	
		if (grabSet.KeyMap[i].keycode == 0)
			continue;

		if (grabSet.KeyMap[i].keycode != AnyModifier) {
			XGrabKey(display, grabSet.KeyMap[i].keycode,
						grabSet.KeyMap[i].modMask | LockMask,
						bb->getScreenInfo(0)->getRootWindow(), True,
						GrabModeAsync, GrabModeAsync);

				/* Also grab all modifier combinations possible that include,
				 * LockMask, ScrollLockMask and NumLockMask, so that keygrabs
				 * work even if the NumLock/ScrollLock key is on.
				 */

			wHackedGrabKey(grabSet.KeyMap[i].keycode,
								grabSet.KeyMap[i].modMask,
								bb->getScreenInfo(0)->getRootWindow(), True,
								GrabModeAsync, GrabModeAsync);
		}

		XGrabKey(display, grabSet.KeyMap[i].keycode,
					grabSet.KeyMap[i].modMask,
					bb->getScreenInfo(0)->getRootWindow(), True, GrabModeAsync,
					GrabModeAsync);
	}
}

/*---------------------------------------------------------------------------*/

/*--	Snarfed shamelessly from WindowMaker's code-base once again....			 --*/

/*---------------------------------------------------------------------------*/
void Keys::wHackedGrabKey(int keycode, unsigned int modifiers,
											Window grab_window, Bool owner_events,
											int pointer_mode, int keyboard_mode)
{
	Display *display = Blackbox::instance()->getXDisplay();
	 
	if (modifiers == AnyModifier)
		return;
	if (keycode == AnyKey)
		return;

	 /* grab all combinations of the modifier with CapsLock, NumLock and
		* ScrollLock. How much memory/CPU does such a monstrosity consume
		* in the server?
		*/
	if (_NumLockMask) {
		XGrabKey(display, keycode, modifiers | _NumLockMask,
					grab_window, owner_events, pointer_mode, keyboard_mode);
	}
	if (_ScrollLockMask) {
			XGrabKey(display, keycode, modifiers | _ScrollLockMask,
						grab_window, owner_events, pointer_mode, keyboard_mode);
	}
	if (_NumLockMask && _ScrollLockMask) {
		XGrabKey(display, keycode,
					modifiers | _NumLockMask | _ScrollLockMask, grab_window,
					owner_events, pointer_mode, keyboard_mode);
	}
	if (_NumLockMask) {
		XGrabKey(display, keycode,
					modifiers | _NumLockMask | LockMask, grab_window,
					owner_events, pointer_mode, keyboard_mode);
	}
	if (_ScrollLockMask) {
		XGrabKey(display, keycode,
					modifiers | _ScrollLockMask | LockMask, grab_window,
					owner_events, pointer_mode, keyboard_mode);
	}
	
	if (_NumLockMask && _ScrollLockMask) {
		XGrabKey(display, keycode,
					modifiers | _NumLockMask | _ScrollLockMask | LockMask,
					grab_window, owner_events, pointer_mode, keyboard_mode);
	}
	 /* phew, I guess that's all, right? */
}

void Keys::getOffendingModifiers(void)
{
	Display *display = Blackbox::instance()->getXDisplay();
	int i;
	XModifierKeymap *modmap;
	KeyCode nlock, slock;
	static int mask_table[8] = {
		ShiftMask, LockMask, ControlMask, Mod1Mask,
		Mod2Mask, Mod3Mask, Mod4Mask, Mod5Mask
	};

	nlock = XKeysymToKeycode(display, XK_Num_Lock);
	slock = XKeysymToKeycode(display, XK_Scroll_Lock);

	 /*
		* Find out the masks for the NumLock and ScrollLock modifiers,
		* so that we can bind the grabs for when they are enabled too.
		*/
	 modmap = XGetModifierMapping(display);

	 if (modmap != NULL && modmap->max_keypermod > 0) {
			for (i = 0; i < 8 * modmap->max_keypermod; i++) {
				if (modmap->modifiermap[i] == nlock && nlock != 0)
					 _NumLockMask = mask_table[i / modmap->max_keypermod];
				else if (modmap->modifiermap[i] == slock && slock != 0)
					 _ScrollLockMask = mask_table[i / modmap->max_keypermod];
			}
	 }

	 if (modmap)
			XFreeModifiermap(modmap);
}

/*-------------------------------------------------------------------------*/

/*--	End of shameful code-snarf.....................................		 --*/

/*-------------------------------------------------------------------------*/

//translateAction
//translate the string to an action num
int Keys::translateAction(char *action)
{
	 if (!action)
			return 0;
	//find action in action list
	for (unsigned int i=0; actions[i].action!=0; i++)
		if (strcasecmp(action, actions[i].action) == 0)
			return actions[i].grabaction;
			
	return 0;
}

void Keys::loadKeygrabs(const char *rcfile)
{
	 if (!strlen(rcfile))
	 	return;
	 // free up pointers that we get with strdup for execCommand....
	 for (register int i = 0; i < grabSet.instructCount; i++) {
			if (grabSet.KeyMap[i].execCommand != NULL) {
				free(grabSet.KeyMap[i].execCommand);
			}
	 }
	 memset(&actionList, 0, sizeof(actionList));

	 /* re-initialize our grabSet count... */
	 grabSet.instructCount = 0;

	 int count = 0;
	 char line[1024];
	 char Keytograb[80];
	 char Modifier[80];
	 char action[80];
	 char execCommand[500];
	 char *KeytograbBegin;
	 char *ModifierBegin;
	 char *actionBegin;
	 char *execCmdBegin;

	 FILE *rc_file = fopen(rcfile, "r");
	 if (!rc_file) {
	 		cerr<<"Fluxbox: Cant open "<<rcfile<<endl;
			return;
	 }

	 memset(line, '\0', 1024);

	 while (fgets(line, 1024, rc_file) && !feof(rc_file) &&
				count < MaxInstructions) {
			if (line[0] != '#' && strstr(line, "WithModifier")) {

				memset(Keytograb, '\0', 80);
				memset(Modifier, '\0', 80);
				memset(action, '\0', 80);
				memset(execCommand, '\0', 500);

				KeytograbBegin = strchr(line, '(');
				ModifierBegin = strchr(KeytograbBegin + 1, '(');
				actionBegin = strchr(ModifierBegin + 1, '(');

				strncat(Keytograb, KeytograbBegin + 1,
							strcspn(KeytograbBegin + 1, ")"));
				strncpy(Modifier, ModifierBegin + 1,
							strcspn(ModifierBegin + 1, ")"));
				strncpy(action, actionBegin + 1,
							strcspn(actionBegin + 1, ")"));

				grabSet.KeyMap[count].keycode = XKeysymToKeycode(
																			Blackbox::instance()->getXDisplay(),
																				 XStringToKeysym
																				 (Keytograb));

				char *k;
				char *tmp = (char *) Modifier;
				grabSet.KeyMap[count].modMask = 0;
				while ((k = strchr(tmp, '+')) != 0) {
					 *k = 0;
					 grabSet.KeyMap[count].modMask |= translateModifier(tmp);
					 tmp = k + 1;
				}
				grabSet.KeyMap[count].modMask |= translateModifier(tmp);

				grabSet.KeyMap[count].action = translateAction(action);
				// save off a cross-reference for action->grabSet.KeyMap[index]
				actionList[grabSet.KeyMap[count].action] = count;

				/* if we're supposed to having an execCommand and we do have
				 * something to put into it																	*/
				if (grabSet.KeyMap[count].action == grabExecute) {
					 execCmdBegin = strchr(actionBegin + 1, '(');
					 if (execCmdBegin) {
							strncpy(execCommand, execCmdBegin + 1,
									 strcspn(execCmdBegin + 1, ")"));
							grabSet.KeyMap[count].execCommand =
								strdup(execCommand);
					 }
				} else {
					 grabSet.KeyMap[count].execCommand = 0;
				}

#ifdef DEBUG
				fprintf(stdout, "Keysym ->%d(%s)<-, Modifier ->0x%lx<-, "
							"action ->%d<-, execCommand ->%s<-\n",							
							grabSet.KeyMap[count].keycode, Keytograb,
							grabSet.KeyMap[count].modMask,
							grabSet.KeyMap[count].action, 
							grabSet.KeyMap[count].execCommand);
#endif
				count++;

			}
	 }
	 fclose(rc_file);
	 grabSet.instructCount = count;
#ifdef DEBUG
	 fprintf(stderr, "loaded ->%d<- instructions.\n", count);
#endif
}

/*****************************************
 *																			 *
 * END OF KEY GRABBING/HANDLING ROUTINES *
 *																			 *
 *****************************************/

Keys::Keys(const char *rcfile)
{

	
	XrmInitialize();

	InitializeModifiers();

	_NumLockMask = 0;
	_ScrollLockMask = 0;

	/*
	 * Ignore CapsLock in modifiers
	 */
	ValidModMask = 0xff & ~LockMask;

	getOffendingModifiers();
	/*
	 * Ignore NumLock and ScrollLock too
	 */
	ValidModMask &= ~(_NumLockMask | _ScrollLockMask);

	// initialize it so we don't run into problems later
	grabSet.instructCount = 0;
	loadKeygrabs(rcfile);
	activateKeygrabs();

}

Keys::~Keys()
{

}

int Keys::getAction(XKeyPressedEvent *ke) {
		
	//clear out numlock, scrolllock and lockmask
	ke->state &= ~_NumLockMask & ~_ScrollLockMask & ~LockMask;
	
	//clear exec_command so we dont accidently use getExecCommand
	exec_command.erase();
	
	for (unsigned int i = 0; i < grabSet.instructCount; i++) {
		if ((ke->keycode == grabSet.KeyMap[i].keycode) &&
				(ke->state == grabSet.KeyMap[i].modMask)) {
			//if its grabExecute set exec_command to command
			if (grabSet.KeyMap[i].action==grabExecute)
				exec_command = string(grabSet.KeyMap[i].execCommand);
			return grabSet.KeyMap[i].action;
		}
	}
}

const char *Keys::getActionString(int action) {
	for (unsigned int i=0; actions[i].action!=0; i++)
		if (actions[i].grabaction == action)
			return actions[i].action;
}

//getExecCommand
const char *Keys::getExecCommand() {
		return exec_command.c_str();
}

unsigned int Keys::KeycodeToModmask(unsigned int code)
{
	switch (XKeycodeToKeysym(Blackbox::instance()->getXDisplay(), code, 0)) {
		case XK_Shift_L:
		case XK_Shift_R:
			return ShiftMask;

		case XK_Caps_Lock:
		case XK_Shift_Lock:
			return LockMask;

		case XK_Control_L:
		case XK_Control_R:
			return ControlMask;

		case XK_Alt_L:
		case XK_Alt_R:
      return Mod1Mask;

		case XK_Num_Lock:
      return Mod2Mask;

		case XK_Meta_L:
		case XK_Meta_R:
      return Mod1Mask;

		case XK_Scroll_Lock:
      return Mod5Mask;
	}
	return (unsigned int)-1;
}


